﻿Imports System.Collections
Imports System.Collections.Generic
Imports DomainModel

Namespace Contacts_MVVM.Converters
	Public MustInherit Class EnumDataProvider(Of T)
    Private _data As System.Collections.IEnumerable

    Public ReadOnly Property Data() As System.Collections.IEnumerable
      Get
        If Me._data Is Nothing Then
          Dim enumType As Type = GetType(T)
          Dim list As New List(Of Object)()
          Dim value As Integer = 0

          Do While System.Enum.IsDefined(enumType, value)
            list.Add(System.Enum.ToObject(enumType, value))
            value += 1
          Loop

          Me._data = list
        End If

        Return Me._data
      End Get
    End Property
	End Class

	Public NotInheritable Class StateCodeDataProvider
		Inherits EnumDataProvider(Of StateCode)
	End Class
End Namespace
