﻿Namespace DomainModel
	Public Class ContactPhotoFinder
		Implements IContactPhotoFinder
		Public Function GetPhotoUriFromId(ByVal id As String) As Uri Implements IContactPhotoFinder.GetPhotoUriFromId
			id = If(id, String.Empty)
			Dim photoFilename As String
			If Not IdFilenameMap.TryGetValue(id.Trim().ToUpper(), photoFilename) Then
			   photoFilename = NewContactFilename
			End If
			Return New Uri(ImageBase & photoFilename, UriKind.RelativeOrAbsolute)
		End Function

		Private Const NewContactFilename As String ="NewContact.png"
		Private Const ImageBase As String = "/Contacts_MVVM;component/Assets/Photos/"
		Private Shared ReadOnly IdFilenameMap As New Dictionary(Of String, String)() From {{"CARIN", "0.jpg"}, {"JOSE", "1.jpg"}, {"DIEGO", "2.jpg"}, {"PETER", "3.jpg"}, {"MARIA", "4.jpg"}, {"LINO", "5.jpg"}, {"EDUAR", "6.jpg"}, {"PAOLO", "7.jpg"}, {"ANDRE", "8.jpg"}, {"MARTI", "9.jpg"}}
	End Class
End Namespace
