﻿Imports DomainModel

Namespace Contacts_MVVM.ViewModels
	''' <summary>
	''' Represents a contact view model for the contact list in ContactsView.
	''' Includes only several members of the model to demonstrate MVVM concept.
	''' </summary>
	Public Class ContactViewModel
		Inherits ViewModelBase
		' Fields
		Private _contact As Contact

		' Constructor
		Public Sub New(ByVal contact As Contact)
			_contact = contact
		End Sub

		' Views
		Public ReadOnly Property Contact() As Contact
			Get
				Return Me._contact
			End Get
		End Property

		Public ReadOnly Property EmailUri() As String
			Get
				Return "mailto:" & _contact.Email
			End Get
		End Property
	End Class
End Namespace
