﻿Imports System.Windows
Imports Intersoft.Client.Framework
Imports Intersoft.Client.Framework.Input
Imports Intersoft.Client.UI.Aqua.UXDesktop

Namespace Contacts_MVVM.ViewModels
	Public Class DialogBoxServiceProvider
		Friend Shared ContactEditView As String = "Contacts_MVVM.Views.ContactEditDialogBox"

		Friend Shared Function GetInstance(ByVal viewType As String) As IModalWindow
			Return TryCast(UXShell.Current.GetApplication(App.ApplicationID).CreateInstance(viewType), IModalWindow)
		End Function

		Friend Shared Sub GetInstanceAsync(ByVal viewType As String, ByVal resultCallback As Action(Of IModalWindow))
			UXShell.Current.GetApplication(App.ApplicationID).CreateInstanceAsync(Sub(result)
				Dim asyncResult As InstanceLoaderAsyncResult = CType(result, InstanceLoaderAsyncResult)
				If asyncResult.IsCompleted Then
					If asyncResult.Error Is Nothing Then
						resultCallback(CType(asyncResult.Instance, IModalWindow))
					Else
						Throw New TypeLoadException("Unable to create the specified type", asyncResult.Error)
					End If
				End If
			End Sub, viewType, Nothing)
		End Sub

		Friend Shared Sub Show(ByVal modalWindow As IModalWindow, ByVal resultCallback As Action(Of DialogResult))
			Dim element As FrameworkElement = TryCast(ISFocusManager.GetFocusedElement(), FrameworkElement)
			Dim owner As IWindow = Nothing

			' check if the caller is hosted within a known container
			' if the dependency container is of IWindow type, use it as the owner of this modal window
			If element IsNot Nothing Then
				Dim logicalContainer As DependencyObject = ISFocusManager.GetLogicalContainerScope(element)

				If TypeOf logicalContainer Is IWindow Then
					owner = TryCast(logicalContainer, IWindow)
				End If
			End If

			modalWindow.ShowDialog(owner, resultCallback)
		End Sub

		Friend Shared Sub CloseCurrentWindow()
			Dim element As FrameworkElement = TryCast(ISFocusManager.GetFocusedElement(), FrameworkElement)
			Dim window As IWindow = UXWindow.GetWindowHost(element)

			If window IsNot Nothing Then
				window.Close()
			End If
		End Sub
	End Class
End Namespace
