﻿Imports DomainModel

Namespace Contacts_MVVM.ViewModels
	''' <summary>
	''' Contact Editor.
	''' </summary>
	Public Interface IContactEditor
		''' <summary>
		''' Opens the ContactEditor to edit the provided Contact
		''' </summary>
		''' <param name="contact">Contact to edit which must exist.</param>
		''' <param name="onOk">
		''' Action taken if the user OKs the edit session; 
		''' the parameter is the saved Contact.
		''' </param>
		''' <param name="onCancel">Action taken if the user cancels the edit.</param>
		Sub EditExistingContact(ByVal contact As Contact, ByVal onOk As Action(Of Contact), ByVal onCancel As Action)

		''' <summary>
		''' Opens the ContactEditor to create a new Contact and edit it.
		''' </summary>
		''' <param name="onOk">
		''' Action taken if the user OKs the edit session; 
		''' the parameter is the newly created and saved Contact.
		''' </param>
		''' <param name="onCancel">Action taken if the user cancels the edit.</param>
		Sub AddNewContact(ByVal onOk As Action(Of Contact), ByVal onCancel As Action)

	End Interface
End Namespace