﻿Imports System.Windows
Imports Intersoft.Client.Framework
Imports Intersoft.Client.Framework.Input
Imports Intersoft.Client.UI.Aqua.UXDesktop
Imports Intersoft.Client.UI.Aqua

Namespace Contacts_MVVM.ViewModels
  Public Class MessageBoxServiceProvider
    Friend Shared ReadOnly Property Owner() As IWindow
      Get
        Dim element As FrameworkElement = TryCast(ISFocusManager.GetFocusedElement(), FrameworkElement)
        'INSTANT VB NOTE: The local variable owner was renamed since Visual Basic will not allow local variables with the same name as their enclosing function or property:
        Dim owner_Renamed As IWindow = Nothing

        ' check if the caller is hosted within a known container
        ' if the dependency container is of IWindow type, use it as the owner of this modal window
        If element IsNot Nothing Then
          Dim logicalContainer As DependencyObject = ISFocusManager.GetLogicalContainerScope(element)

          If TypeOf logicalContainer Is IWindow Then
            owner_Renamed = TryCast(logicalContainer, IWindow)
          End If
        End If

        Return owner_Renamed
      End Get
    End Property

    Friend Shared Sub Show(ByVal message As String, ByVal resultCallback As Action(Of DialogResult))
      UXMessageBox.Show(Owner, message, resultCallback)
    End Sub

    Friend Shared Sub Show(ByVal message As String, ByVal caption As String, ByVal resultCallback As Action(Of DialogResult))
      UXMessageBox.Show(Owner, message, caption, resultCallback)
    End Sub

    Friend Shared Sub Show(ByVal message As String, ByVal caption As String, ByVal button As Intersoft.Client.UI.Aqua.UXDesktop.MessageBoxButton, ByVal resultCallback As Action(Of DialogResult))
      UXMessageBox.Show(Owner, message, caption, button, resultCallback)
    End Sub

    Friend Shared Sub Show(ByVal message As String, ByVal caption As String, ByVal button As Intersoft.Client.UI.Aqua.UXDesktop.MessageBoxButton, ByVal image As Intersoft.Client.UI.Aqua.UXDesktop.MessageBoxImage, ByVal resultCallback As Action(Of DialogResult))
      UXMessageBox.Show(Owner, message, caption, button, image, resultCallback)
    End Sub
  End Class
End Namespace
