Imports Intersoft.Client.Framework
Imports Intersoft.Client.UI.Aqua.UXDesktop

Namespace Contacts_MVVM.ViewModels
	Public Interface IMessagePresenter
		Sub ShowInformationMessage(ByVal message As String)
		Sub ShowErrorMessage(ByVal message As String)
    'Sub AskYesOrNo(ByVal question As String, Optional ByVal yesAction As Action = Nothing, Optional ByVal noAction As Action = Nothing) DEK Don't use optional parameters in VB
    Sub AskYesOrNo(ByVal question As String, ByVal yesAction As Action, ByVal noAction As Action)
  End Interface

	Public Class MessagePresenter
		Implements IMessagePresenter
		Public Sub ShowInformationMessage(ByVal message As String) Implements IMessagePresenter.ShowInformationMessage
			MessageBoxServiceProvider.Show(message, "Information", MessageBoxButton.OK, MessageBoxImage.Information, Nothing)
		End Sub

		Public Sub ShowErrorMessage(ByVal message As String) Implements IMessagePresenter.ShowErrorMessage
			MessageBoxServiceProvider.Show(message, "Error", MessageBoxButton.OK, MessageBoxImage.Error, Nothing)
		End Sub

		Public Sub AskYesOrNo(ByVal question As String, ByVal yesAction As Action, ByVal noAction As Action) Implements IMessagePresenter.AskYesOrNo
			MessageBoxServiceProvider.Show("Are you sure you want to delete the selected contact?", "Confirmation", MessageBoxButton.YesNo, MessageBoxImage.Question, Sub(dialogResult)
				If dialogResult = DialogResult.Yes Then
					If yesAction IsNot Nothing Then
						yesAction()
					End If
				Else
					If noAction IsNot Nothing Then
						noAction()
					End If
				End If
			End Sub)
		End Sub
	End Class
End Namespace