
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 11/14/2010 22:53:18
-- Generated from EDMX file: ...\DomainModel\DataModel.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [IntersoftSample];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_Contact_PostalAddress]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Contact] DROP CONSTRAINT [FK_Contact_PostalAddress];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Contact]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Contact];
GO
IF OBJECT_ID(N'[dbo].[PostalAddress]', 'U') IS NOT NULL
    DROP TABLE [dbo].[PostalAddress];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Contacts'
CREATE TABLE [dbo].[Contacts] (
    [ContactID] uniqueidentifier  NOT NULL,
    [Id] varchar(50)  NOT NULL,
    [Name] varchar(200)  NOT NULL,
    [Email] varchar(max)  NULL,
    [AddressID] uniqueidentifier  NULL,
    [Phone] nvarchar(max)  NULL,
    [Fax] nvarchar(max)  NULL,
    [Cell] nvarchar(max)  NULL,
    [Twitter] nvarchar(max)  NULL,
    [Website] nvarchar(max)  NULL,
    [Blog] nvarchar(max)  NULL
);
GO

-- Creating table 'PostalAddresses'
CREATE TABLE [dbo].[PostalAddresses] (
    [AddressID] uniqueidentifier  NOT NULL,
    [Address] nvarchar(max)  NOT NULL,
    [StateCodeName] varchar(2)  NOT NULL,
    [ZipCode] varchar(10)  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [ContactID] in table 'Contacts'
ALTER TABLE [dbo].[Contacts]
ADD CONSTRAINT [PK_Contacts]
    PRIMARY KEY CLUSTERED ([ContactID] ASC);
GO

-- Creating primary key on [AddressID] in table 'PostalAddresses'
ALTER TABLE [dbo].[PostalAddresses]
ADD CONSTRAINT [PK_PostalAddresses]
    PRIMARY KEY CLUSTERED ([AddressID] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [AddressID] in table 'Contacts'
ALTER TABLE [dbo].[Contacts]
ADD CONSTRAINT [FK_Contact_PostalAddress]
    FOREIGN KEY ([AddressID])
    REFERENCES [dbo].[PostalAddresses]
        ([AddressID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_Contact_PostalAddress'
CREATE INDEX [IX_FK_Contact_PostalAddress]
ON [dbo].[Contacts]
    ([AddressID]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------